'$DYNAMIC
DECLARE SUB fillTable (ATable() AS ANY)
DECLARE SUB viewPic (AInFile AS STRING, AOffset AS LONG, ASize AS LONG)
DECLARE SUB checkFile (AFilename AS STRING)
DECLARE FUNCTION fileExists% (AFilename AS STRING)

CONST FALSE = 0
CONST TRUE = NOT FALSE
CONST ARCHIVEFILE = "cells.001"

TYPE tableType
  offset AS LONG
  filesize AS LONG
  filename AS STRING * 12
END TYPE

PRINT "Bugs Bunny Hare-Brained Adventure. Frenkel. 01-02-2008."

checkFile ARCHIVEFILE

DIM table(0 TO 0) AS tableType
fillTable table()

i% = LBOUND(table)
viewPic table(i%).filename, table(i%).offset, table(i%).filesize

DIM k AS STRING
DO
  k = INKEY$
  IF k = CHR$(0) + "M" THEN                             'Right
    IF i% < UBOUND(table) THEN
      i% = i% + 1
      viewPic table(i%).filename, table(i%).offset, table(i%).filesize
    END IF
  ELSEIF k = CHR$(0) + "K" THEN                         'Left
    IF LBOUND(table) < i% THEN
      i% = i% - 1
      viewPic table(i%).filename, table(i%).offset, table(i%).filesize
    END IF
  ELSEIF k = CHR$(0) + "G" THEN                         'Home
    IF i% <> LBOUND(table) THEN
      i% = LBOUND(table)
      viewPic table(i%).filename, table(i%).offset, table(i%).filesize
    END IF
  ELSEIF k = CHR$(0) + "O" THEN                         'End
    IF i% <> UBOUND(table) THEN
      i% = UBOUND(table)
      viewPic table(i%).filename, table(i%).offset, table(i%).filesize
    END IF
  ELSEIF k = CHR$(27) THEN                              'Escape
    END
  END IF
LOOP

REM $STATIC
SUB checkFile (AFilename AS STRING)

IF NOT fileExists(AFilename) THEN
  PRINT "File " + AFilename + " does not exist."
  PRINT "Press any key to continue . . . "
  DO WHILE INKEY$ = ""
  LOOP
  END
END IF

END SUB

FUNCTION fileExists% (AFilename AS STRING)

DIM ff AS INTEGER 'free file number
DIM fs AS LONG    'filesize

ff = FREEFILE
OPEN AFilename FOR BINARY AS ff
fs = LOF(ff)
CLOSE ff

IF fs = 0 THEN
  KILL AFilename
  fileExists% = FALSE
ELSE
  fileExists% = TRUE
END IF

END FUNCTION

SUB fillTable (ATable() AS tableType)
DIM ffi AS INTEGER 'free file number
DIM N   AS INTEGER 'number of files in archive

ffi = FREEFILE
OPEN ARCHIVEFILE FOR BINARY AS ffi

'Calculate number of files N
DIM o AS STRING * 3
GET ffi, 2, o
a% = ASC(MID$(o, 1, 1))
b% = ASC(MID$(o, 2, 1))
c% = ASC(MID$(o, 3, 1))
e& = c% * 256& * 256 + b% * 256& + a%
SEEK ffi, 8
N = 0
DO WHILE NOT (p& = e&)
  GET ffi, , o
  a% = ASC(MID$(o, 1, 1))
  b% = ASC(MID$(o, 2, 1))
  c% = ASC(MID$(o, 3, 1))
  p& = c% * 256& * 256 + b% * 256& + a%
  N = N + 1
LOOP
N = N - 1


REDIM ATable(0 TO N - 1) AS tableType


'fill offset column in ATable
SEEK ffi, 8
FOR i% = 0 TO N - 1
  GET ffi, , o
  a% = ASC(MID$(o, 1, 1))
  b% = ASC(MID$(o, 2, 1))
  c% = ASC(MID$(o, 3, 1))
  ATable(i%).offset = c% * 256& * 256 + b% * 256& + a%
NEXT i%


'fill filesize column in ATable
FOR i% = 0 TO N - 2
  ATable(i%).filesize = ATable(i% + 1).offset - ATable(i%).offset
NEXT i%
ATable(N - 1).filesize = LOF(ffi) - ATable(N - 1).offset
CLOSE ffi


'fill filename column in ATable
'initialize
FOR i% = 0 TO N - 1
  ATable(i%).filename = LTRIM$(STR$(i%))
NEXT i%

CLOSE ffi

END SUB

SUB viewPic (AInFile AS STRING, AOffset AS LONG, ASize AS LONG)

DIM byte AS STRING * 1
OPEN ARCHIVEFILE FOR BINARY AS #1
SEEK #1, AOffset + 1
GET #1, , c%
GET #1, , w%
GET #1, , h%

IF c% <> 0 THEN
  LOCATE 1, 1
  PRINT "check failed:"; c%
  PRINT AInFile
ELSE

SCREEN 1
CLS
FOR y% = 0 TO h% - 1
  IF (w% / 4) - INT(w% / 4) > 0 THEN w% = (INT(w% / 4) + 1) * 4
  FOR x% = 0 TO (w% / 4) - 1
    GET #1, , byte
    PSET (x% * 4 + 0 + w%, y%), (ASC(byte) AND 192) \ 64
    PSET (x% * 4 + 1 + w%, y%), (ASC(byte) AND 48) \ 16
    PSET (x% * 4 + 2 + w%, y%), (ASC(byte) AND 12) \ 4
    PSET (x% * 4 + 3 + w%, y%), (ASC(byte) AND 3) \ 1
    GET #1, , byte
    PSET (x% * 4 + 0, y%), (ASC(byte) AND 192) \ 64
    PSET (x% * 4 + 1, y%), (ASC(byte) AND 48) \ 16
    PSET (x% * 4 + 2, y%), (ASC(byte) AND 12) \ 4
    PSET (x% * 4 + 3, y%), (ASC(byte) AND 3) \ 1
  NEXT x%
NEXT y%

END IF

CLOSE

END SUB

